VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form frmBitviewer 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "BitViewer"
   ClientHeight    =   840
   ClientLeft      =   150
   ClientTop       =   720
   ClientWidth     =   1560
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   840
   ScaleWidth      =   1560
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   960
      Top             =   240
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      Filter          =   "Bitfile (*.bit)|*.bit|Bitmap (*.bmp)|*.bmp|All files (*.*)|*.*"
   End
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      BackColor       =   &H8000000E&
      Height          =   840
      Left            =   0
      ScaleHeight     =   48
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   96
      TabIndex        =   0
      Top             =   0
      Width           =   1545
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open"
      End
      Begin VB.Menu mnuSaveAs 
         Caption         =   "&Save As..."
      End
   End
End
Attribute VB_Name = "frmBitviewer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub mnuFileOpen_Click()
On Error GoTo ErrorHandler

    Dim r, x, y As Integer
    Dim byteChar As Byte
    Dim strBinary As String
    Dim strFilename As String
    Dim strFiletype As String
    
    CommonDialog1.ShowOpen
    strFilename = CommonDialog1.FileName
    strFiletype = LCase(Right(strFilename, 3))
    
    If strFilename <> "" Then
        Picture1.Cls 'Clear bitmap area
        If strFiletype = "bit" Then
            Open strFilename For Binary Access Read As #1
            For r = 0 To 5 '6 rows of 8 bits for a total height of 48 pixels
                For x = 1 To 96 '96 pixels wide
                    Get #1, x + (r * 96), byteChar
                    For y = 0 To 7
                        If byteChar And 2 ^ y Then 'is bit set?
                            Picture1.PSet (x - 1, y + (8 * r)), 0
                        End If
                    Next
                Next
            Next
            Close #1
        Else
            If strFiletype = "bmp" Then
                Picture1.Picture = LoadPicture(strFilename)
            End If
        End If
    End If

ErrorHandler:
'general error trap... if there's a real problem I'll fix it.
End Sub

Private Sub mnuSaveAs_Click()
On Error GoTo ErrorHandler

    Dim r, x, y As Integer
    Dim byteChar As Byte
    Dim strFilename As String
    Dim strFiletype As String
    
    CommonDialog1.ShowSave
    strFilename = CommonDialog1.FileName
    strFiletype = LCase(Right(strFilename, 3))
    
    If strFilename <> "" Then
        If strFiletype = "bit" Then
            Open strFilename For Binary Access Write As #1
            For r = 0 To 5 '6 rows of 8 bits for a total height of 48 pixels
                For x = 1 To 96 '96 pixels wide
                    byteChar = 0
                    For y = 0 To 7 'build byte value
                        If Picture1.Point(x - 1, y + (8 * r)) = 0 Then
                            byteChar = byteChar + (2 ^ y)
                        End If
                    Next
                    Put #1, x + (r * 96), byteChar
                Next
            Next
            Close #1
        Else
            If strFiletype = "bmp" Then
                SavePicture Picture1.Image, strFilename
            End If
        End If
    End If
    
ErrorHandler:
'general error trap... if there's a real problem I'll fix it.
End Sub
